###########################################################################

# 1. Testy sú kamaráti, nie nepriatelia.

###########################################################################

# 2. Prečo sa nespustí doctest?

def funkce4(seznam: list):
    """
    >>> funkce4(["3", "22", "330", "27", "8", "10"])
    ['3', '330', '27']
    """  # Doctest musí byť vždy na začiatku funkcie.
    delitelne_tremi = []
    for i in seznam:
        i = float(i)
        if i%3 == 0:
            delitelne_tremi.append(str(int(i)))
    return delitelne_tremi 

###########################################################################

# 3. Čo je špatne?

def funkce2(retezec: str) -> str:
    while retezec.startswith("_"):
        retezec = retezec[1:]
    while retezec.endswith("_"):
        retezec = retezec[:-1]  # Index za dvojbodkou označuje prvý prvok, ktorý už nebude vo výbere, tj. 'ahoj'[-1] vráti 'j', ale 'ahoj'[:-1] vráti 'aho'.
    return f"_{retezec}_"

print(funkce2('___Hello_World___'))

# Ešte jednoduchšie použiť metódu .strip('_').

###########################################################################

# 4. Čo je špatne?

seznam = list('___Hello_World___')
for i in range(0, len(seznam)):  # Druhý argument funkcie range() označuje prvé číslo, ktoré už nebude vo výsledku, tj. range(0, 5) vráti čísla 0, 1, 2, 3, 4.
    if seznam[i]=='_':
        seznam[i]="*"
print(''.join(seznam))

###########################################################################

# 5. Čo je špatne?

retezec = '_Hello_World'
if retezec[0] != '_' and retezec[-1] != '_':  
    # Operátor is / is not testuje, či dve premenné ukazujú na jeden objekt, == / != testuje, či hodnoty premenných sú rovnaké.
    #   Skúste si porovnať ('ahoj'.capitalize() is 'Ahoj') a ('ahoj'.capitalize() == 'Ahoj')
    # Výraz (retezec[0] != '_' and retezec[-1] != '_') sa nedá skrátiť na (retezec[0] and retezec[-1] != '_').
    retezec = '_' + retezec + '_'
print(retezec)

###########################################################################

# 6. Čo je špatne?

def funkce5(jmena: str) -> tuple:
    records = jmena.split(";")
    ages = {}
    for i in records:
        key, value = i.split(",")
        ages[key] = float(value)
    oldest = max(ages, key=ages.get)
    youngest = min(ages, key=ages.get)
    average = float(sum(ages.values())) / len(ages)
    result = (youngest, oldest, average)
    return result

print(funkce5("Jan,20;Martin,26;Filip,25;Petr,30;Marek,25"))

# Pokiaľ možno, dávajte premenným zmysluplné názvy. Pomôže to prehľadnosti kódu a ľahšie odhalíte chyby.

###########################################################################

# 7. Prečo nebude fungovať správne? 
# (Kód má vytlačiť zoznam čísel včetne ich poradia. Čísla väčšie/rovné 1000 a menšie než 0.001 má vypísať vo vedeckom zápise).

seznam = [1.2, 5.5, 2000, 5.5]
for i, value in enumerate(seznam):
    if 0.001 <= value < 1000:  # ako to zjednodušiť?
        print(f"{i:<6} {value:>7.1f}")
    else:
        print(f"{i:<6} {value:>7.1E}")
pass

# Pre logické operácie sa v Pythone používa and a or. Operátory & a | existujú, ale majú iný význam než and a or. 

# Ak chceme iterovať zoznam a potrebujeme vedieť index jednotlivých prvkov, najjednoduchšie je použiť funkciu enumerate().
# Riešenia pomocou (i += 1) alebo seznam[i] fungujú, ale sú menej prehľadné. Riešenie pomocou metódy .index() nefunguje, ak je v zozname viac rovnakých hodnôt.
# https://docs.quantifiedcode.com/python-anti-patterns/readability/using_an_unpythonic_loop.html?highlight=enumerate  
       
###########################################################################     

# 8. Šlo by to krajšie?

slovnik = {'green': 'zelená', 'blue': 'modrá', 'yellow': 'žlutá'}
for klic, hodnota in slovnik.items():
    print(klic, '=', hodnota)
pass

# Pre iterovanie kľúčov a hodnôt v slovníku je najjednoduchšie použiť metódu .items(). (Podobne ako u zoznamu enumerate().)
# https://docs.quantifiedcode.com/python-anti-patterns/readability/not_using_items_to_iterate_over_a_dictionary.html
      
###########################################################################    

# 9. Šlo by to krajšie? 

slovnik = {'green': 'zelená', 'blue': 'modrá', 'yellow': 'žlutá'}
for klic, hodnota in slovnik.items():
    print(klic, '=', hodnota)
pass

# slovnik.items() nám vráti presne to, čo zložitý zápis zip(slovnik.keys(), slovnik.values()).

###########################################################################

# 10. Šlo by to krajšie?
# (Kód má zo zoznamu vybrať reťazce reprezentujúce prirodzené čísla.)

seznam = ["1", "22", "33.3", "-44", "5555.5", "66", "1000"]
new = []
for value in seznam:
    if  "." not in value and int(value) > 0: 
        new.append(value)
print(new)

# Je zbytočné porovnávať logické hodnoty voči True. Namiesto (("." not in seznam[i]) == True) stačí napísať ("." not in seznam[i]).

###########################################################################

# 11. Funguje, ale...
# (Kód má zo zoznamu vybrať čísla menšie/rovné 1000.)

vstup = [1.2, 5.5, 2000, 5.5]
vysl = [x for x in vstup if x <= 1000]
print(vysl)

# Použitie [... for ... in ... if ...] je väčšinou najjednoduchší spôsob, ako prefiltrovať zoznam.

###########################################################################

# 12. Funguje, ale...

dvojice = ['Jan,20', 'Martin,26', 'Filip,25', 'Petr,30', 'Marek,25']
slovnik = {}
for dvojica in dvojice:
    klic, hodnota = dvojica.split(',')
    slovnik[klic] = hodnota 
print(slovnik)

# slovnik.update({klic:hodnota}) zbytočne vytvára ďalší slovník. 
# slovnik[klic] = hodnota je rýchlejšie a prehľadnejšie.

###########################################################################

# 13. Šlo by to krajšie?
# (Kód ma vypísať posledný znak reťazca.)

retezec = 'Ahoj'
print(retezec[-1])  

# Pre indexovanie zoznamov alebo reťazcov od konca môžeme použiť záporné indexy. Index -1 zodpovedá poslednému prvku.

###########################################################################

# 14. Funguje, ale...
# (Kód má vybrať zo zoznamu reťazcov tie, ktoré reprezentujú násobky čísla 3.)

def funkce4(seznam: list):
    delitelne_tremi = []
    for i in seznam:
        if int(i) % 3 == 0:
            delitelne_tremi.append(i)
    return delitelne_tremi 

print(funkce4(["3", "22", "330", "27", "8", "10"]))

# Pretypovanie str -> float -> int -> str v pôvodnom riešení je zbytočné.
# Operátor % funguje aj s hodnotami typu float, ale väčšinou sa používa s typom int (keďže počíta zvyšok po CELOČÍSELNOM delení).

###########################################################################

# 15. Ako formátovať výstup?

i = 1
x = 5.5

print('%-6d %9.3f' % (i, x))  # Old school

print('{:<6d} {:9.3f}'.format(i, x))  # Less old school

print(f'{i:<6d} {x:9.3f}')  # This got da swag

print(f"{i:<6}{' '}{x:9.3f}")  # Unnecessary {' '}

# Formátovanie pomocou f-strings sa považuje za najprehľadnejšie a je väčšinou najkratšie.
# (V starých verziách Pythonu sa musí formátovať pomocou % alebo .format().)

# https://realpython.com/python-f-strings/

###########################################################################

# 16. Funguje, ale...

seznam = ['Adam', 'Elisabeth', 'Johny', 'Mark', 'Mary', 'Peter', 'Susane']
a = ';'.join(seznam)
print(a)

# Metóda .join() nám ušetrí veľa práce.

###########################################################################

# 17. Funguje, ale...

retezec = 'anakonda'
if retezec[0] == retezec[-1]:
    print(retezec)
pass

# Reťazce sa dajú indexovať tak ako zoznamy.
# (Avšak jednotlivé znaky reťazca sa nedajú meniť, kdežto u zoznamu sa to dá.)

###########################################################################
